theory remove_relaxed_stack
imports Main insert_pr_relaxed_stack
begin

locale remove_relaxed_stack = wellformed_history +
  fixes ir :: "'a rel"
  assumes pr_abcd : "abcd pre"
  assumes val_then_pr: "(a, b) \<in> val \<Longrightarrow> (a, b) \<in> pre"
  assumes ir_alternating: "alternating val ir"
  assumes pr_u_ir_acyclic: "acyclic (pre \<union> ir)"
  assumes rem_ooo : "(ia, ra) \<in> val \<Longrightarrow> (ib, rb) \<in> val \<Longrightarrow> (ia, ib) \<in> (ins_order pre val ir) \<Longrightarrow> 
                     (ib, ra) \<in> ir \<Longrightarrow> (ra, rb) \<notin> (rem_order pre val ir)"
  assumes pops_finite_def : "finite {a. isPop val a}"

lemma remove_relaxed_stackI : "wellformed_history pre val f \<Longrightarrow> abcd pre \<Longrightarrow>
\<forall> a b . (a, b) \<in> val \<longrightarrow> (a, b) \<in> pre \<Longrightarrow>
alternating val ir \<Longrightarrow>
acyclic (pre \<union> ir) \<Longrightarrow>
\<forall> ia ra ib rb . (ia, ra) \<in> val \<longrightarrow> (ib, rb) \<in> val \<longrightarrow> (ia, ib) \<in> (ins_order pre val ir) \<longrightarrow> 
                                   (ib, ra) \<in> ir \<longrightarrow> (ra, rb) \<notin> (rem_order pre val ir) \<Longrightarrow>
remove_relaxed_stack pre val f ir"
apply (unfold remove_relaxed_stack_def)
apply (rule conjI)
apply (assumption)
apply (unfold remove_relaxed_stack_axioms_def)
apply (rule conjI)+
apply assumption
apply (rule conjI)
apply assumption+
apply (rule conjI)+
apply assumption+
apply (rule conjI)
apply (assumption)
by (metis finite_Collect_disjI wellformed_historyD)

lemma remove_relaxed_stackD : "remove_relaxed_stack pre val f ir \<Longrightarrow>
wellformed_history pre val f \<and> abcd pre \<and>
(\<forall> a b . (a, b) \<in> val \<longrightarrow> (a, b) \<in> pre) \<and>
alternating val ir \<and>
acyclic (pre \<union> ir) \<and>
(\<forall> ia ra ib rb . (ia, ra) \<in> val \<longrightarrow> (ib, rb) \<in> val \<longrightarrow> (ia, ib) \<in> (ins_order pre val ir) \<longrightarrow> 
                                   (ib, ra) \<in> ir \<longrightarrow> (ra, rb) \<notin> (rem_order pre val ir))"
apply (unfold remove_relaxed_stack_def)
apply (unfold remove_relaxed_stack_axioms_def)
by metis

lemma order_correct_then_remove_relaxed_stack : "linearizable_set pre val emp \<Longrightarrow> order_correct pre val \<Longrightarrow> 
  \<exists> ir f . remove_relaxed_stack (elimination_free_pre (non_empty_pre pre emp) val) (elimination_free_val (non_empty_pre pre emp) val) f (elimination_free_ir (non_empty_pre pre emp) val ir)"
apply (frule linearizable_set_then_wellformed)
apply (erule exE)
apply (drule order_correctD)
apply (erule exE)
apply (rule_tac x="ir" in exI)
apply (rule_tac x="f" in exI)
apply (erule conjE)+
apply (rule remove_relaxed_stackI)
apply (metis wellformed_then_ef_wellformed)
apply (metis conc_history.abcd ef_conc_history linearizable_set_def pre_conc_history_then_non_empty_pre_conc_history)
apply (rule allI)+
apply (rule impI)
apply (drule elimination_free_valD)
apply (rule elimination_free_preI)
apply metis
apply metis
apply (erule conjE)+
apply (drule elimination_freeD)
apply (drule wellformed_historyD)
apply (erule exE)
apply (erule conjE)+
apply (erule disjE)
apply (drule sameValD)
apply (erule disjE)
apply (metis pop_once_def)
apply (metis val_order_def)
apply (metis sameValD val_order_def val_then_not_pr_def)
apply (metis alternating_then_ef_alternating)
apply (rule_tac s="(pre \<union> ir)" in acyclic_subset)
apply (metis (erased, hide_lams) Un_commute)
apply (metis ef_empty_mono ef_ir_in_ir subset_refl sup.mono)
apply (rule allI)+
apply (rule impI)+
apply (rule notI)
apply (erule_tac x="ia" in allE)
apply (erule_tac x="ra" in allE)
apply (erule_tac x="ib" in allE)
apply (erule impE)
apply (rule conjI)
apply (metis elimination_free_valD)
apply (rule conjI)
apply (metis ef_val_then_pre)
apply (rule conjI)
apply (drule ins_orderD)
apply (erule conjE)+
apply (erule disjE)
apply (rule ins_orderI1)
apply (metis elimination_free_valD isPushI)
apply (metis elimination_free_valD isPushI)
apply (metis elimination_free_preD non_empty_pre_then_pre)
apply (metis (erased, hide_lams) ef_ins_then_ins elimination_free_irD ins_orderI2)
apply (drule ins_orderD)
apply (erule conjE)+
apply (erule disjE)
apply (metis elimination_free_irD)
apply (metis elimination_free_irD)
apply (erule exE)
apply (erule conjE)
apply (frule_tac f="f" in elim_ef_rem_then_rem)
apply (assumption)
by (metis elimination_free_valD empty_rem_then_rem pop_once_def wellformed_history.def_pop_once)

context remove_relaxed_stack
begin

lemma pops_finite : "finite {a. is_pop a}"
by (metis Collect_cong isPopD isPopI is_popD lem_val_then_push_and_pop pops_finite_def)

lemma push_pop_ordered : "is_push a \<Longrightarrow>is_pop b \<Longrightarrow> (a, b) : ir \<or> (b,a) \<in> ir"
by (metis alternating_def ir_alternating isPop_def isPush_def is_pushD lem_pop_then_push_exists)

lemma ir_push_and_pop : "(a, b) \<in> ir \<Longrightarrow> (is_push a \<and> is_pop b) \<or> (is_pop a \<and> is_push b)"
by (metis alternating_def ir_alternating isPop_def isPush_def lem_val_then_push_and_pop)

definition ins :: "'a rel"
where
  "ins = ins_order pre val ir"

lemma lem_pr_then_ins : " is_push a \<Longrightarrow> is_push b \<Longrightarrow> (a, b) \<in> pre \<Longrightarrow> (a, b) \<in> ins"
apply (unfold ins_def)
apply (unfold ins_order_def)
apply (simp add: set_eq_iff)
by (metis isPush_def is_pushD)

lemma ir_push_and_pop1 : "(a, b) \<in> ir \<Longrightarrow> is_push a \<Longrightarrow> is_pop b"
by (metis def_value ir_push_and_pop is_push_def lem_pop_then_push_exists val_order_def)

lemma ir_push_and_pop2 : "(a, b) \<in> ir \<Longrightarrow> is_push b \<Longrightarrow> is_pop a"
by (metis def_value ir_push_and_pop is_push_def lem_pop_then_push_exists val_order_def)

lemma ir_push_and_pop3 : "(a, b) \<in> ir \<Longrightarrow> is_pop a \<Longrightarrow> is_push b"
by (metis def_value ir_push_and_pop is_push_def lem_pop_then_push_exists val_order_def)

lemma ir_push_and_pop4 : "(a, b) \<in> ir \<Longrightarrow> is_pop b \<Longrightarrow> is_push a"
by (metis def_value ir_push_and_pop is_push_def lem_pop_then_push_exists val_order_def)

lemma insI : "is_push a \<Longrightarrow> is_push b \<Longrightarrow> (a, c) \<in> pre \<Longrightarrow> (c, b) \<in> ir \<Longrightarrow> (a, b) \<in> ins"
by (metis ins_def ins_orderI2 isPush_def lem_push_then_pop_exists)

lemma insD : "(a, b) \<in> ins \<Longrightarrow> is_push a \<and> is_push b \<and> ((a, b) \<in> pre \<or>(\<exists> c . is_pop c \<and> (a, c) \<in> pre \<and> (c, b) \<in> ir))"
by (metis (hide_lams, no_types) ins_def ins_orderD ir_push_and_pop2 isPush_def lem_val_then_push_and_pop)

lemma ipr_ooo : "(ia, ra) \<in> val \<Longrightarrow> (ib, rb) \<in> val \<Longrightarrow> (ia, ib) \<in> (ins_order pre val ir) \<Longrightarrow> (ib, ra) \<in> ir \<Longrightarrow> (ra, rb) \<notin> pre"
apply (drule_tac ib="ib" and rb="rb" in rem_ooo)
apply (assumption)+
apply (rule notI)
by (metis ir_push_and_pop1 isPop_def is_popD lem_val_then_push_and_pop rem_orderI1)

lemma ipr_ooo_ir : "(ia, ra) \<in> val \<Longrightarrow> (ib, rb) \<in> val \<Longrightarrow> (ia, ib) \<in> (ins_order pre val ir) \<Longrightarrow> (ib, ra) \<in> ir \<Longrightarrow> \<not>((ra, ic) \<in> ir \<and> (ic, rb) \<in> ir)"
apply (drule_tac ib="ib" and rb="rb" in rem_ooo)
apply (assumption)+
apply (rule notI)
by (metis (hide_lams, no_types) alternating_def def_value ir_alternating isPop_def rem_orderI2 val_order_def)

lemma lem_val_then_ir : "(a, b) \<in> val \<Longrightarrow> (a, b) \<in> ir"
apply (frule val_then_pr)
apply (frule lem_val_then_push_and_pop)
apply (erule conjE)
apply (frule_tac a="a" and b="b" in push_pop_ordered)
apply (assumption)
apply (erule disjE)
apply (assumption)
apply (frule_tac c="(a, b)" and A="pre" and B="ir" in UnI1)
apply (frule_tac c="(b, a)" and A="pre" and B="ir" in UnI2)
apply (frule_tac a="a" and b="b" and c="a" and R ="pre Un ir" in r_r_into_trancl)
apply (assumption)+
by (metis acyclic_def pr_u_ir_acyclic)

lemma lem_push_pr_pop_then_ir : " is_push a \<Longrightarrow> is_pop b \<Longrightarrow> (a, b) \<in> pre \<Longrightarrow> (a, b) \<in> ir"
apply (frule_tac a="a" and b="b" in push_pop_ordered)
apply (assumption)
apply (erule disjE)
apply (assumption)
apply (frule_tac c="(a, b)" and A="pre" and B="ir" in UnI1)
apply (frule_tac c="(b, a)" and A="pre" and B="ir" in UnI2)
apply (frule_tac a="a" and b="b" and c="a" and R ="pre Un ir" in r_r_into_trancl)
apply (assumption)+
by (metis acyclic_def pr_u_ir_acyclic)

lemma not_ir_push_pop_ir : "(a, b) \<notin> ir \<Longrightarrow> is_push a \<Longrightarrow> is_pop b \<Longrightarrow> (b, a) \<in> ir"
by (metis push_pop_ordered)

lemma not_ir_pop_push_ir : "(a, b) \<notin> ir \<Longrightarrow> is_pop a \<Longrightarrow> is_push b \<Longrightarrow> (b, a) \<in> ir"
by (metis push_pop_ordered)

lemma ir_transitive : "(a, b) \<in> ir \<Longrightarrow> (b, c) \<in> ir \<Longrightarrow> (c, d) \<in> ir \<Longrightarrow> (a, d) \<in> ir"
apply (case_tac "(a, d) \<in> ir")
apply (assumption)
apply (frule ir_push_and_pop)
apply (erule disjE)
apply (erule conjE)
apply (drule not_ir_push_pop_ir)
apply (assumption)
apply (metis ir_push_and_pop1 ir_push_and_pop3)
apply (frule_tac c="(a, b)" and A="pre" and B="ir" in UnI2)
apply (frule_tac c="(b, c)" and A="pre" and B="ir" in UnI2)
apply (frule_tac c="(c, d)" and A="pre" and B="ir" in UnI2)
apply (frule_tac c="(d, a)" and A="pre" and B="ir" in UnI2)
apply (frule_tac a="a" and b="b" and c="c" and R ="pre Un ir" in r_r_into_trancl)
apply (assumption)
apply (frule_tac a="c" and b="d" and c="a" and R ="pre Un ir" in r_r_into_trancl)
apply (assumption)
apply (metis acyclic_def pr_u_ir_acyclic transE trans_trancl)
apply (drule not_ir_pop_push_ir)
apply (erule conjE)
apply (assumption)
apply (metis ir_push_and_pop1 ir_push_and_pop3)
apply (frule_tac c="(a, b)" and A="pre" and B="ir" in UnI2)
apply (frule_tac c="(b, c)" and A="pre" and B="ir" in UnI2)
apply (frule_tac c="(c, d)" and A="pre" and B="ir" in UnI2)
apply (frule_tac c="(d, a)" and A="pre" and B="ir" in UnI2)
apply (frule_tac a="a" and b="b" and c="c" and R ="pre Un ir" in r_r_into_trancl)
apply (assumption)
apply (frule_tac a="c" and b="d" and c="a" and R ="pre Un ir" in r_r_into_trancl)
apply (assumption)
by (metis acyclic_def pr_u_ir_acyclic transE trans_trancl)

lemma lem_pop_pr_push_then_ir : " is_pop a \<Longrightarrow> is_push b \<Longrightarrow> (a, b) \<in> pre \<Longrightarrow> (a, b) \<in> ir"
apply (frule_tac a="b" and b="a" in push_pop_ordered)
apply (assumption)
apply (erule disjE)
apply (frule_tac c="(a, b)" and A="pre" and B="ir" in UnI1)
apply (frule_tac c="(b, a)" and A="pre" and B="ir" in UnI2)
apply (frule_tac a="a" and b="b" and c="a" and R ="pre Un ir" in r_r_into_trancl)
apply (assumption)+
by (metis acyclic_def pr_u_ir_acyclic)

lemma lem_ins_transitive : "trans ins"
apply (rule transI)
apply (drule insD)+
apply (erule conjE)+
apply (erule disjE)+
apply (metis pre_transitive lem_pr_then_ins transE)
apply (metis pre_transitive insI transE)
apply (erule disjE)
apply (smt abcdD ins_def insI ipr_ooo_ir lem_pop_then_push_exists lem_pr_then_ins lem_push_pr_pop_then_ir lem_push_then_pop_exists pr_abcd val_then_pr)
by (metis insI ir_transitive lem_push_pr_pop_then_ir)

lemma lem_ins_abcd : "abcd ins"
apply (rule abcdI)
apply (drule insD)+
apply (erule conjE)+
apply (erule disjE)+
apply (metis abcdD lem_pr_then_ins pr_abcd)
apply (metis abcdD insI lem_pr_then_ins pr_abcd)
by (metis abcdD insI lem_pr_then_ins pr_abcd)

lemma lem_ins_irreflexive : "irrefl ins"
apply (unfold irrefl_def)
apply (rule allI)
apply (rename_tac x)
apply (rule notI)
apply (drule insD)
apply (erule conjE)+
apply (erule disjE)
apply (metis pre_irreflexive lem_irreflexive_then_not_equal)
apply (erule exE)
apply (erule conjE)+
apply (frule_tac c="(x, c)" and A="pre" and B="ir" in UnI1)
apply (frule_tac c="(c, x)" and A="pre" and B="ir" in UnI2)
apply (frule_tac a="x" and b="c" and c="x" and R ="pre Un ir" in r_r_into_trancl)
apply (assumption)
by (metis acyclic_def pr_u_ir_acyclic)


definition lin :: "'a rel" 
  where
    "lin = {(ra, rb) . (\<exists> ia ib . (ia, ra) \<in> val \<and> (ib, rb) \<in> val \<and> (ib, ia) \<in> ins \<and> (ia, rb) \<in> ir)}"

lemma linD : "(ra, rb) \<in> lin \<Longrightarrow> (\<exists> ia ib . (ia, ra) \<in> val \<and> (ib, rb) \<in> val \<and> (ib, ia) \<in> ins \<and> (ia, rb) \<in> ir)"
apply (unfold lin_def)
by (simp add: set_eq_iff)

lemma linI : "(ia, ra) \<in> val \<Longrightarrow> (ib, rb) \<in> val \<Longrightarrow> (ia, rb) \<in> ir \<Longrightarrow> (ib, ia) \<in> ins \<Longrightarrow> (ra, rb) \<in> lin"
apply (unfold lin_def)
apply (simp add: set_eq_iff)
apply (rule_tac x="ia" in exI)
apply (rule conjI)
apply (assumption)
apply (rule_tac x="ib" in exI)
apply (rule conjI)
apply (assumption)
apply (rule conjI)
by (assumption)+

definition pop_ir :: "'a rel" 
  where
    "pop_ir = {(ra, rb) . is_pop ra \<and> is_pop rb \<and> (\<exists> ic . (ra, ic) \<in> ir \<and> (ic, rb) \<in> ir)}"

lemma pop_irD : "(a, b) \<in> pop_ir \<Longrightarrow> is_pop a \<and> is_pop b \<and> (\<exists> ic . (a, ic) \<in> ir \<and> (ic, b) \<in> ir)"
apply (unfold pop_ir_def)
by (simp add: set_eq_iff)

lemma pop_irI : "is_pop a \<Longrightarrow> is_pop b \<Longrightarrow> (a, c) \<in> ir \<Longrightarrow> (c, b) \<in> ir \<Longrightarrow> (a, b) \<in> pop_ir"
apply (unfold pop_ir_def)
apply (simp add: set_eq_iff)
by metis

lemma lem_pop_ir_transitive : "trans pop_ir"
apply (rule transI)
apply (drule pop_irD)+
apply (erule conjE)+
apply (erule exE)+
apply (erule conjE)+
apply (case_tac "(x, ica) \<in> ir")
apply (metis pop_irI)
apply (drule not_ir_pop_push_ir)
apply (assumption)
apply (metis ir_push_and_pop3)
apply (frule_tac c="(ica, x)" and A="pre" and B="ir" in UnI2)
apply (frule_tac c="(x, ic)" and A="pre" and B="ir" in UnI2)
apply (frule_tac c="(ic, y)" and A="pre" and B="ir" in UnI2)
apply (frule_tac c="(y, ica)" and A="pre" and B="ir" in UnI2)
apply (frule_tac a="x" and b="ic" and c="y" and R ="pre Un ir" in r_r_into_trancl)
apply (assumption)
apply (frule_tac a="y" and b="ica" and c="x" and R ="pre Un ir" in r_r_into_trancl)
apply (assumption)
by (metis acyclic_def pr_u_ir_acyclic transD trans_trancl)

lemma lem_pop_ir_irreflexive : "irrefl pop_ir"
apply (unfold irrefl_def)
apply (rule allI)
apply (rule notI)
apply (rename_tac x)
apply (drule pop_irD)
apply (erule conjE)+
apply (erule exE)
apply (erule conjE)
apply (frule_tac c="(ic, x)" and A="pre" and B="ir" in UnI2)
apply (frule_tac c="(x, ic)" and A="pre" and B="ir" in UnI2)
apply (frule_tac a="x" and b="ic" and c="x" and R ="pre Un ir" in r_r_into_trancl)
apply (assumption)
by (metis acyclic_def pr_u_ir_acyclic)

lemma lem_pop_ir_abcd : "abcd pop_ir"
apply (rule abcdI)
apply (drule pop_irD)+
apply (erule conjE)+
apply (erule exE)+
apply (erule conjE)+
by (metis (hide_lams, no_types) ir_push_and_pop3 lem_pop_ir_transitive pop_irI push_pop_ordered trans_def)

lemma lem_lin_irreflexive : "irrefl lin"
apply (unfold irrefl_def)
apply (rule allI)
apply (rule notI)
apply (unfold lin_def)
apply (simp add: set_eq_iff)
apply (erule exE)
apply (erule conjE)
apply (erule exE)
apply (erule conjE)+
by (metis def_push_once lem_ins_irreflexive lem_irreflexive_then_not_equal push_once_def)

lemma lem_lin_transitive : "trans lin"
apply (rule transI)
apply (rename_tac rc rb ra)
apply (unfold lin_def)
apply (simp add: set_eq_iff)
apply (erule exE)+
apply (rename_tac ic ib)
apply (erule conjE)+
apply (erule exE)+
apply (rename_tac ibb ia)
apply (erule conjE)+
apply (rule_tac x="ic" in exI)
apply (rule conjI)
apply (assumption)
apply (rule_tac x="ia" in exI)
by (smt ins_def def_push_once ipr_ooo_ir lem_ins_transitive lem_val_then_push_and_pop not_ir_push_pop_ir push_once_def transE)

lemma lem_prUlin_irreflexive: "irrefl (pre Un lin)"
by (metis pre_irreflexive Un_iff irrefl_def lem_lin_irreflexive)

lemma lem_lin_u_pop_ir_transitive : "trans (lin Un pop_ir)"
apply (rule transI)
apply (erule UnE)+
apply (metis UnI1 lem_lin_transitive transD)
apply (drule pop_irD)
apply (erule conjE)+
apply (erule exE)
apply (erule conjE)
apply (case_tac "(x, ic) \<in> ir")
apply (metis UnCI ir_push_and_pop2 ir_push_and_pop3 pop_irI)
apply (smt ins_def ipr_ooo_ir ir_push_and_pop3 is_pop_def linD not_ir_pop_push_ir)
apply (erule UnE)
apply (drule pop_irD)
apply (erule conjE)+
apply (erule exE)
apply (erule conjE)
apply (case_tac "(ic, z) \<in> ir")
apply (metis UnCI ir_push_and_pop1 ir_push_and_pop3 pop_irI)
apply (smt ins_def ipr_ooo_ir ir_push_and_pop3 is_pop_def linD not_ir_pop_push_ir)
by (metis UnI2 lem_pop_ir_transitive transD)

lemma lem_lin_u_pop_ir_irreflexive : "irrefl (lin Un pop_ir)"
by (metis UnE irrefl_def lem_lin_irreflexive lem_pop_ir_irreflexive)

lemma prUlinD : "(a, e) \<in> trancl (pre \<union> lin) \<Longrightarrow>(a, e) \<in> pre \<or> (a, e) \<in> lin \<or> (\<exists> b .(a, b) \<in> lin \<and> (b, e) \<in> pre) \<or> (\<exists> b. (a, b) \<in> pre \<and> (b, e) \<in> lin) \<or> (\<exists> b c .(a, b) \<in> lin \<and> (b, c) \<in> pre \<and> (c, e) \<in> lin)"
apply (erule trancl.induct)
apply (metis UnE)
apply (erule disjE)
apply (erule UnE)
apply (metis pre_transitive transD)
apply metis
apply (erule UnE)
apply (erule disjE)
apply metis
apply (erule disjE)
apply (metis pre_transitive transD)
apply (erule disjE)
apply (erule exE)
apply (erule conjE)
apply (insert pr_abcd)
apply (frule_tac a="a" and b="ba" and c="b" and d="c" and r="pre" in abcdD)
apply (assumption)+
apply (erule disjE)
apply (rule disjI1)
apply (assumption)

apply (metis ins_def ipr_ooo linD)
apply (metis (full_types) ins_def abcdD ipr_ooo linD)
by (metis lem_lin_transitive transD)

lemma lem_prUlin_acyclic: "acyclic (pre \<union> lin)"
apply (unfold acyclic_def)
apply (rule allI)
apply (rule notI)
apply (drule prUlinD)
apply (erule disjE)+
apply (metis pre_irreflexive lem_irreflexive_then_not_equal)
apply (erule disjE)+
apply (metis lem_irreflexive_then_not_equal lem_lin_irreflexive)
apply (erule disjE)+
apply (metis ins_def ipr_ooo linD)
apply (erule disjE)+
apply (metis ins_def ipr_ooo linD)
apply (erule exE)+
apply (insert lem_lin_transitive)
apply (erule conjE)+
apply (drule_tac r="lin" and x="c" and y="x" and z="b" in transD)
apply (assumption)+
by (metis ins_def ipr_ooo linD)

lemma lem_pre_then_not_pop_ir : "(a, b) \<in> pre \<Longrightarrow> (b, a) \<in> pop_ir \<Longrightarrow> False"
apply (unfold pop_ir_def)
apply (simp add: set_eq_iff)
apply (erule conjE)+
apply (erule exE)
apply (erule conjE)
apply (frule_tac c="(a, b)" and A="pre" and B="ir" in UnI1)
apply (frule_tac c="(b, ic)" and A="pre" and B="ir" in UnI2)
apply (frule_tac c="(ic, a)" and A="pre" and B="ir" in UnI2)
by (metis Un_commute acyclic_def pr_u_ir_acyclic r_into_trancl' r_r_into_trancl trancl_trans)

lemma prUirUlinD : "(a, b) \<in> trancl (pre \<union> (lin \<union> pop_ir)) \<Longrightarrow> (a, b) \<in> (pre \<union> (lin \<union> pop_ir)) \<or> 
                                                              (\<exists> c . (a, c) \<in> pre \<and> (c, b) \<in> (lin \<union> pop_ir)) \<or>
                                                              (\<exists> c . (a, c) \<in> (lin \<union> pop_ir) \<and> (c, b) \<in> pre) \<or>
                                                              (\<exists> c d . (a, c) \<in> (lin \<union> pop_ir) \<and> (c, d) \<in> pre \<and> (d, b) \<in> (lin \<union> pop_ir))" 
apply (erule trancl.induct)
apply (rule disjI1)
apply (assumption)
apply (erule disjE)+
apply (erule UnE)+
apply (metis pre_transitive UnI1 transD)
apply metis
apply (erule UnE)+
apply (metis UnI1)
apply (metis UnI2)
apply (metis UnCI lem_lin_u_pop_ir_transitive sup_commute transD)
apply (erule UnE)
apply (erule disjE)+
apply (erule exE)
apply (erule conjE)
apply (insert pr_abcd)
apply (drule_tac r="pre" and a="b" and b="c" and c="a" and d="ca" in abcdD)
apply (assumption)+
apply (erule disjE)
apply (erule UnE)
apply (metis ins_def ipr_ooo linD)
apply (frule_tac c="(b, ca)" and A="pre" and B="pop_ir" in UnI1)
apply (frule_tac c="(ca, b)" and A="pre" and B="pop_ir" in UnI2)
apply (metis lem_pre_then_not_pop_ir)
apply (metis UnI1)
apply (erule disjE)
apply (erule exE)
apply (erule conjE)
apply (metis pre_transitive transE)
apply (erule exE)+
apply (erule conjE)+
apply (drule_tac r="pre" and a="b" and b="c" and c="ca" and d="d" in abcdD)
apply (assumption)+
apply (erule disjE)
apply (erule_tac c="(d, b)" in UnE)
apply (metis ins_def ipr_ooo linD)
apply (frule_tac c="(b, d)" and A="pre" and B="pop_ir" in UnI1)
apply (frule_tac c="(d, b)" and A="pre" and B="pop_ir" in UnI2)
apply (metis lem_pre_then_not_pop_ir)
apply metis
apply (erule disjE)
apply (erule exE)
apply (erule conjE)
apply (metis lem_lin_u_pop_ir_transitive transE)
apply (erule disjE)
apply (erule exE)
apply (erule conjE)
apply metis
apply (erule exE)+
apply (erule conjE)+
by (metis lem_lin_u_pop_ir_transitive transE)

lemma lem_pr_ir_lin_acyclic : "acyclic (pre \<union> (lin \<union> pop_ir))"
apply (unfold acyclic_def)
apply (rule allI)
apply (rule notI)
apply (drule prUirUlinD)
apply (erule disjE)
apply (metis UnE lem_irreflexive_then_not_equal lem_lin_u_pop_ir_irreflexive pre_irreflexive)
apply (erule disjE)
apply (erule exE)
apply (erule conjE)+
apply (erule UnE)
apply (metis ins_def ipr_ooo linD)
apply (frule_tac c="(x, c)" and A="pre" and B="pop_ir" in UnI1)
apply (frule_tac c="(c, x)" and A="pre" and B="pop_ir" in UnI2)
apply (metis lem_pre_then_not_pop_ir)
apply (erule disjE)
apply (erule exE)
apply (erule conjE)
apply (erule UnE)
apply (metis ins_def ipr_ooo linD)
apply (frule_tac c="(c, x)" and A="pre" and B="pop_ir" in UnI1)
apply (frule_tac c="(x, c)" and A="pre" and B="pop_ir" in UnI2)
apply (metis lem_pre_then_not_pop_ir)
apply (erule exE)+
apply (erule conjE)+
apply (insert lem_lin_u_pop_ir_transitive)
apply (drule_tac r="(lin Un pop_ir)" and x="d" and y="x" and z="c" in transD)
apply (assumption)+
apply (erule_tac c="(d, c)" in UnE)
apply (metis ins_def ipr_ooo linD)
apply (frule_tac c="(c, d)" and A="pre" and B="pop_ir" in UnI1)
apply (frule_tac c="(d, c)" and A="pre" and B="pop_ir" in UnI2)
by (metis lem_pre_then_not_pop_ir)

definition w1 :: "'a rel"
where
  "w1 = trancl (pre \<union> (lin \<union> pop_ir))"

definition wins1 :: "'a rel"
where
  "wins1 = {(a, b) . is_push a \<and> is_push b \<and> ((a, b) \<in> w1 \<or> (\<exists> c . is_pop c \<and> (a, c) \<in> w1 \<and> (c, b) \<in> ir))}"

lemma lem_trancl_w1D : "(x, y) \<in> trancl w1 \<Longrightarrow> (x, y) \<in> w1"
by (metis trancl_id trans_trancl w1_def)

lemma lem_w1_transitive : "trans w1"
by (metis trans_trancl w1_def)

lemma lem_w1_irreflexive : "irrefl w1"
by (metis acyclic_irrefl lem_pr_ir_lin_acyclic w1_def)

lemma lem_w1_acyclic : "acyclic w1"
by (metis lem_transitive_irreflexive_then_acyclic lem_w1_irreflexive lem_w1_transitive)

lemma w1D : "(a, b) \<in> w1 \<Longrightarrow> (a, b) \<in> (pre \<union> (lin \<union> pop_ir)) \<or> 
                                                              (\<exists> c . (a, c) \<in> pre \<and> (c, b) \<in> (lin \<union> pop_ir)) \<or>
                                                              (\<exists> c . (a, c) \<in> (lin \<union> pop_ir) \<and> (c, b) \<in> pre) \<or>
                                                              (\<exists> c d . (a, c) \<in> (lin \<union> pop_ir) \<and> (c, d) \<in> pre \<and> (d, b) \<in> (lin \<union> pop_ir))"
by (metis prUirUlinD w1_def)

lemma lem_w1_then_push_or_pop1 : "(a, b) \<in> w1 \<Longrightarrow> is_push a \<or> is_pop a"
apply (drule w1D)
apply (erule disjE)
apply (metis Un_iff lem_push_or_pop1 lem_val_then_push_and_pop linD pop_irD)
apply (erule disjE)
apply (metis lem_push_or_pop1)
apply (erule disjE)
apply (metis Un_iff lem_val_then_push_and_pop linD pop_irD)
by (metis Un_iff lem_val_then_push_and_pop linD pop_irD)

lemma lem_w1_then_push_or_pop2 : "(a, b) \<in> w1 \<Longrightarrow> is_push b \<or> is_pop b"
apply (drule w1D)
apply (erule disjE)
apply (metis Un_commute Un_iff is_pop_def lem_push_or_pop2 linD pop_irD)
apply (erule disjE)
apply (metis Un_iff is_pop_def linD pop_irD)
apply (erule disjE)
apply (metis lem_push_or_pop2)
by (metis Un_iff lem_val_then_push_and_pop linD pop_irD)

lemma lem_w1_push_then_pr : "(a, b) \<in> w1 \<Longrightarrow> is_push a \<Longrightarrow> is_push b \<Longrightarrow> (a, b) \<in> pre"
apply (drule w1D)
apply (erule disjE)
apply (erule UnE)
apply (assumption)
apply (erule UnE)
apply (metis def_value lem_push_then_pop_exists linD val_order_def)
apply (metis irrefl_def lem_pop_ir_irreflexive pop_irD pop_irI push_pop_ordered)
apply (erule disjE)
apply (erule exE)
apply (erule conjE)
apply (erule UnE)
apply (metis def_value lem_push_then_pop_exists linD val_order_def)
apply (metis irrefl_def lem_pop_ir_irreflexive pop_irD pop_irI push_pop_ordered)
apply (erule disjE)
apply (erule exE)
apply (erule conjE)
apply (erule UnE)
apply (metis def_value is_push_def linD val_order_def)
apply (metis irrefl_def lem_pop_ir_irreflexive pop_irD pop_irI push_pop_ordered)
apply (erule exE)+
apply (erule conjE)+
apply (erule UnE)
apply (metis def_value lem_push_then_pop_exists linD val_order_def)
by (metis lem_irreflexive_then_not_equal lem_pop_ir_irreflexive pop_irD pop_irI push_pop_ordered)

lemma lem_wins1_then_ins : "(a, b) \<in> wins1 \<Longrightarrow> (a, b) \<in> ins"
apply (unfold wins1_def)
apply (simp add: set_eq_iff)
apply (erule conjE)+
apply (erule disjE)
apply (drule w1D)
apply (erule disjE)
apply (metis lem_pr_then_ins lem_w1_push_then_pr r_into_trancl' w1_def)
apply (erule disjE)
apply (erule exE)
apply (erule conjE)
apply (erule UnE)
apply (metis def_value lem_push_then_pop_exists linD val_order_def)
apply (metis def_value is_pop_def lem_push_then_pop_exists pop_irD val_order_def)
apply (erule disjE)
apply (erule exE)
apply (erule conjE)
apply (erule UnE)
apply (metis def_value lem_push_then_pop_exists linD val_order_def)
apply (metis def_value is_push_def lem_pop_then_push_exists pop_irD val_order_def)
apply (erule exE)+
apply (erule conjE)+
apply (erule UnE)
apply (metis def_value lem_push_then_pop_exists linD val_order_def)
apply (metis def_value is_pop_def lem_push_then_pop_exists pop_irD val_order_def)
apply (erule exE)
apply (erule conjE)+
apply (drule w1D)
apply (erule disjE)
apply (erule UnE)
apply (metis insI)
apply (erule UnE)
apply (metis def_value is_push_def linD val_order_def)
apply (metis def_value is_push_def lem_pop_then_push_exists pop_irD val_order_def)
apply (erule disjE)
apply (erule exE)
apply (erule conjE)
apply (erule UnE)

apply (smt insI ins_def ipr_ooo_ir lem_val_then_push_and_pop linD not_ir_push_pop_ir)
apply (metis insI ir_transitive lem_irreflexive_then_not_equal lem_pop_ir_irreflexive not_ir_push_pop_ir pop_irD pop_irI)
apply (erule disjE)
apply (erule exE)
apply (erule conjE)
apply (erule UnE)
apply (metis def_value lem_push_then_pop_exists linD val_order_def)
apply (metis def_value is_pop_def lem_push_then_pop_exists pop_irD val_order_def)
apply (erule exE)+
apply (erule conjE)+
apply (erule UnE)+
apply (metis def_value lem_push_then_pop_exists linD val_order_def)
apply (metis def_value lem_push_then_pop_exists linD val_order_def)
apply (erule UnE)
apply (metis lem_irreflexive_then_not_equal lem_pop_ir_irreflexive pop_irD pop_irI push_pop_ordered)
by (metis def_value is_pop_def lem_push_then_pop_exists pop_irD val_order_def)

lemma lem_w1_ooo : "(ia, ra) \<in> val \<Longrightarrow> (ib, rb) \<in> val \<Longrightarrow> (ia, ib) \<in> wins1 \<Longrightarrow> (ib, ra) \<in> ir \<Longrightarrow> (rb, ra) \<in> w1"
apply (frule lem_wins1_then_ins)
apply (drule_tac ia="ib" and ib="ia" and ra="rb" and rb="ra" in linI)
apply (assumption)+
by (metis UnCI r_into_trancl' w1_def)

lemma lem_pr_ir_then_ir : "is_push a \<Longrightarrow> is_push b \<Longrightarrow> is_pop c \<Longrightarrow> (a, b) \<in> pre \<Longrightarrow> (b, c) \<in> ir \<Longrightarrow> (a, c) \<in> ir"
apply (case_tac "(a, c) \<in> ir")
apply (assumption)
apply (drule not_ir_push_pop_ir)
apply (assumption)+
apply (frule_tac c="(a, b)" and A="pre" and B="ir" in UnI1)
apply (frule_tac c="(b, c)" and A="pre" and B="ir" in UnI2)
apply (frule_tac a="a" and b="b" and c="c" and R ="pre Un ir" in r_r_into_trancl)
apply (assumption)
by (metis Un_iff acyclic_def pr_u_ir_acyclic trancl_into_trancl2)

lemma lem_w1Uir_then_push_or_pop1 : "(a, b) \<in> w1 Un ir \<Longrightarrow> is_push a \<or> is_pop a"
by (metis UnE ir_push_and_pop lem_w1_then_push_or_pop1)

lemma lem_w1Uir_then_push_or_pop2 : "(a, b) \<in> w1 Un ir \<Longrightarrow> is_push b \<or> is_pop b"
by (metis UnE ir_push_and_pop lem_w1_then_push_or_pop2)

lemma lem_trancl_w1UnirD : "(a, b) \<in> trancl(w1 Un ir) \<Longrightarrow>
  (is_push a \<and> is_push b \<and> ((a, b) \<in> pre \<or> (\<exists> c. (a, c)\<in> ir \<and> (c, b)\<in> ir))) \<or>
  (is_push a \<and> is_pop b \<and> (a, b) \<in> ir) \<or>
  (is_pop a \<and> is_push b \<and> (a, b) \<in> ir) \<or>
  (is_pop a \<and> is_pop b \<and> (a, b) \<in> w1)"

apply (erule trancl.induct)
apply (frule lem_w1Uir_then_push_or_pop1)
apply (frule lem_w1Uir_then_push_or_pop2)
apply (erule disjE)+
apply (metis Un_iff ir_push_and_pop1 lem_w1_push_then_pr)

apply (rule disjI2)
apply (rule disjI1)
apply (rule conjI)
apply (assumption)
apply (rule conjI)
apply (assumption)
apply (erule UnE)
apply (drule w1D)
apply (erule disjE)
apply (metis (lifting) UnE def_value lem_pop_then_push_exists lem_push_pr_pop_then_ir lem_push_then_pop_exists linD pop_irD val_order_def)
apply (erule disjE)
apply (erule exE)
apply (erule conjE)
apply (erule UnE)
apply (smt ins_def ipr_ooo_ir lem_push_pr_pop_then_ir lem_val_then_push_and_pop linD push_pop_ordered)
apply (metis ir_transitive lem_push_pr_pop_then_ir pop_irD)
apply (erule disjE)
apply (metis Un_iff def_value is_pop_def is_push_def linD pop_irD val_order_def)
apply (metis UnE Un_commute def_value lem_pop_then_push_exists lem_push_then_pop_exists linD pop_irD val_order_def)
apply (assumption)

apply (erule disjE)
apply (rule disjI2)
apply (rule disjI2)
apply (rule disjI1)
apply (rule conjI)
apply (assumption)
apply (rule conjI)
apply (assumption)
apply (erule UnE)
apply (drule w1D)
apply (erule disjE)
apply (metis (hide_lams, no_types) Un_iff def_value is_pop_def is_push_def lem_pop_pr_push_then_ir linD pop_irD val_order_def)
apply (erule disjE)
apply (metis Un_iff def_value is_pop_def is_push_def linD pop_irD val_order_def)
apply (erule disjE)
apply (erule exE)
apply (erule conjE)
apply (erule UnE)
apply (smt ins_def ipr_ooo_ir lem_pop_pr_push_then_ir lem_val_then_push_and_pop linD push_pop_ordered)
apply (metis ir_transitive lem_pop_pr_push_then_ir pop_irD)
apply (metis UnE Un_commute def_value lem_pop_then_push_exists lem_push_then_pop_exists linD pop_irD val_order_def)
apply (assumption)
apply (rule disjI2)+
apply (rule conjI)
apply (assumption)
apply (rule conjI)
apply (assumption)
apply (metis UnE def_value ir_push_and_pop3 lem_pop_then_push_exists lem_push_then_pop_exists val_order_def)
apply (frule lem_w1Uir_then_push_or_pop2)
apply (erule disjE)+
apply (erule conjE)+
apply (rule disjI1)
apply (rule conjI)
apply (assumption)
apply (rule conjI)
apply (assumption)
apply (erule disjE)
apply (metis pre_transitive Un_iff ir_push_and_pop2 lem_push_pr_pop_then_ir lem_w1_push_then_pr transD)
apply (erule exE)
apply (erule conjE)
apply (erule UnE)
apply (metis (hide_lams, no_types) Un_iff ir_push_and_pop1 lem_irreflexive_then_not_equal lem_lin_u_pop_ir_irreflexive lem_pr_ir_then_ir lem_w1_push_then_pr not_ir_push_pop_ir pop_irI)
apply (metis ir_push_and_pop2 ir_transitive push_pop_ordered)

apply (erule conjE)+
apply (rule disjI2)
apply (rule disjI1)
apply (rule conjI)
apply (assumption)
apply (rule conjI)
apply (assumption)
apply (erule UnE)
apply (erule disjE)
apply (smt lem_ins_irreflexive lem_ins_transitive lem_irreflexive_then_not_equal lem_pr_then_ins lem_wins1_then_ins mem_Collect_eq push_pop_ordered split_conv trans_def wins1_def)
apply (erule exE)
apply (erule conjE)+

apply (smt ir_transitive irrefl_def lem_ins_irreflexive lem_wins1_then_ins mem_Collect_eq case_prodI push_pop_ordered wins1_def)

apply (erule disjE)
apply (metis lem_pr_ir_then_ir)

apply (metis ir_transitive)
apply (erule disjE)+
apply (erule conjE)+
apply (rule disjI1)
apply (rule conjI)
apply (assumption)
apply (rule conjI)
apply (assumption)
apply (rule disjI2)
apply (rule_tac x="b" in exI)
apply (rule conjI)
apply (assumption)
apply (erule UnE)
apply (drule w1D)
apply (erule disjE)
apply (metis (lifting) Un_def def_value is_pop_def lem_pop_pr_push_then_ir lem_push_then_pop_exists linD mem_Collect_eq pop_irD val_order_def)
apply (erule disjE)
apply (metis UnE def_value lem_pop_then_push_exists lem_push_then_pop_exists linD pop_irD val_order_def)
apply (erule disjE)
apply (erule exE)
apply (erule conjE)
apply (erule UnE)
apply (smt ins_def ipr_ooo_ir lem_pop_pr_push_then_ir lem_val_then_push_and_pop linD push_pop_ordered)
apply (metis ir_transitive lem_pop_pr_push_then_ir pop_irD)
apply (erule exE)+
apply (erule conjE)+
apply (erule UnE)+
apply (metis def_value lem_push_then_pop_exists linD val_order_def)
apply (metis def_value is_pop_def lem_push_then_pop_exists pop_irD val_order_def)
apply (erule UnE)
apply (metis def_value lem_push_then_pop_exists linD val_order_def)
apply (metis Un_iff acyclic_irrefl irrefl_def not_ir_push_pop_ir pop_irD pr_u_ir_acyclic r_into_trancl')
apply (assumption)
apply (erule disjE)
apply (erule conjE)+
apply (metis Un_iff ir_push_and_pop2 lem_irreflexive_then_not_equal lem_pop_ir_irreflexive lem_pr_ir_then_ir lem_w1_push_then_pr pop_irI push_pop_ordered)
apply (erule conjE)+
apply (erule UnE)
apply (insert lem_w1_transitive)
apply (drule_tac r="w1" and x="a" and y="b" and z="c" in transD)
apply (assumption)+
apply (drule_tac a="a" and b="c" in w1D)
apply (erule disjE)
apply (metis (lifting) Un_def def_value is_pop_def lem_pop_pr_push_then_ir lem_pop_then_push_exists lem_push_then_pop_exists linD mem_Collect_eq pop_irD  val_order_def)
apply (erule disjE)
apply (metis (hide_lams, no_types) Un_iff lem_val_then_push_and_pop lem_w1_transitive linD pop_irD trans_def)
apply (erule disjE)
apply (smt UnE ins_def ipr_ooo_ir ir_transitive lem_pop_pr_push_then_ir lem_val_then_push_and_pop linD not_ir_pop_push_ir pop_irD)
apply (metis (hide_lams, no_types) Un_iff lem_val_then_push_and_pop lem_w1_transitive linD pop_irD trans_def)
apply (drule w1D)
apply (erule disjE)
apply (erule UnE)
apply (metis lem_pre_then_not_pop_ir not_ir_push_pop_ir pop_irI)
apply (erule UnE)
apply (smt ins_def ipr_ooo_ir linD push_pop_ordered)
apply (metis ir_transitive pop_irD)
apply (erule disjE)
apply (erule exE)
apply (erule conjE)
apply (erule UnE)
apply (drule linD)
apply (erule exE)+
apply (erule conjE)+
apply (metis ins_def ipr_ooo_ir is_pop_def lem_pre_then_not_pop_ir pop_irI push_pop_ordered)
apply (metis lem_pop_ir_transitive lem_pre_then_not_pop_ir not_ir_push_pop_ir pop_irI r_r_into_trancl trancl_id)
apply (erule disjE)
apply (erule exE)
apply (erule conjE)
apply (erule UnE)
apply (smt ins_def ipr_ooo_ir lem_pre_then_not_pop_ir lem_val_then_push_and_pop linD not_ir_pop_push_ir pop_irI)
apply (metis lem_pop_ir_transitive lem_pre_then_not_pop_ir pop_irI push_pop_ordered transD)
apply (erule exE)+
apply (erule conjE)+
apply (erule UnE)+
apply (rule disjI2)
apply (rule disjI2)
apply (rule disjI1)
apply (rule conjI)
apply (assumption)
apply (rule conjI)
apply (assumption)
apply (drule linD)+
apply (erule exE)+
apply (erule conjE)+
apply (metis (hide_lams, no_types) ins_def ipr_ooo_ir is_pop_def lem_pre_then_not_pop_ir pop_irI push_pop_ordered)
apply (rule disjI2)
apply (rule disjI2)
apply (rule disjI1)
apply (rule conjI)
apply (assumption)
apply (rule conjI)
apply (assumption)
apply (drule linD)
apply (erule exE)+
apply (erule conjE)+
apply (smt Collect_mem_eq Un_def ins_def ipr_ooo_ir lem_pop_ir_transitive lem_pre_then_not_pop_ir lem_val_then_push_and_pop not_ir_push_pop_ir pop_irI r_r_into_trancl sup_idem trancl_id val_then_not_pr_def)
apply (erule UnE)
apply (rule disjI2)
apply (rule disjI2)
apply (rule disjI1)
apply (rule conjI)
apply (assumption)
apply (rule conjI)
apply (assumption)
apply (drule linD)
apply (erule exE)+
apply (erule conjE)+
apply (smt ins_def ipr_ooo_ir lem_pop_ir_transitive lem_pre_then_not_pop_ir lem_val_then_push_and_pop not_ir_push_pop_ir pop_irI r_r_into_trancl trancl_id)
apply (metis lem_pop_ir_transitive lem_pre_then_not_pop_ir pop_irI push_pop_ordered trans_def)
apply (erule disjE)
apply (metis Un_iff acyclic_def ir_transitive lem_w1_acyclic not_ir_push_pop_ir pop_irI r_into_trancl' r_r_into_trancl w1_def)
apply (erule disjE)
apply (erule conjE)+
apply (erule UnE)
apply (rule disjI2)+
apply (rule conjI)
apply (assumption)
apply (rule conjI)
apply (assumption)
apply (drule w1D)
apply (erule disjE)
apply (metis (hide_lams, no_types) Un_iff ir_push_and_pop4 lem_push_pr_pop_then_ir lem_val_then_push_and_pop lem_w1_push_then_pr linD not_ir_push_pop_ir pop_irD pop_irI r_into_trancl' w1_def)
apply (erule disjE)
apply (erule exE)
apply (erule conjE)+
apply (drule_tac a="b" and b="ca" in lem_push_pr_pop_then_ir)
apply (metis Un_iff is_pop_def linD pop_irD)
apply (assumption)
apply (erule UnE)
apply (case_tac "(b, c) \<in> ir")
apply (metis (hide_lams, no_types) Un_iff pop_irI r_into_trancl' w1_def)
apply (smt ins_def ipr_ooo_ir ir_push_and_pop3 linD push_pop_ordered)
apply (drule pop_irD)
apply (erule conjE)+
apply (erule exE)
apply (erule conjE)
apply (metis (hide_lams, no_types) Un_iff ir_transitive pop_irI r_into_trancl' w1_def)
apply (erule disjE)
apply (metis UnE def_value lem_pop_then_push_exists lem_push_then_pop_exists linD pop_irD val_order_def)
apply (metis UnE def_value lem_pop_then_push_exists lem_push_then_pop_exists linD pop_irD val_order_def)
apply (metis (hide_lams, no_types) Un_iff pop_irI r_into_trancl' w1_def)
by (metis Un_iff def_value ir_push_and_pop3 ir_push_and_pop4 lem_push_then_pop_exists push_pop_ordered transD val_order_def)

lemma lem_w1_ir_acyclic : "acyclic (w1 Un ir)"
apply (unfold acyclic_def)
apply (safe)
apply (drule lem_trancl_w1UnirD)
apply (safe)
apply (metis pre_irreflexive irrefl_def)
apply (metis ir_push_and_pop2 lem_irreflexive_then_not_equal lem_pop_ir_irreflexive pop_irI)
apply (metis irrefl_def lem_pop_ir_irreflexive pop_irI)
apply (metis irrefl_def lem_pop_ir_irreflexive pop_irI)
by (metis irrefl_def lem_w1_irreflexive)

lemma lem_pr_in_w1 : "pre \<subseteq> w1"
by (metis UnI1 r_into_trancl' subsetI w1_def)

lemma lem_pr_then_w1 : "(a, b) \<in> pre \<Longrightarrow> (a, b) \<in> w1"
by (metis lem_pr_in_w1 set_rev_mp)

lemma lem_lin_then_w1 : "(a, b) \<in> lin \<Longrightarrow> (a, b) \<in> w1"
by (metis Un_iff r_into_trancl' w1_def)

lemma lem_pop_ir_then_w1 : "(a, b) \<in> pop_ir \<Longrightarrow> (a, b) \<in> w1"
by (metis Un_iff r_into_trancl' w1_def)

lemma lem_same_ir : "(a, b) \<notin> w1 \<Longrightarrow> (b, a) \<notin> w1 \<Longrightarrow> is_pop a \<Longrightarrow> is_pop b \<Longrightarrow> (\<forall> e . (e, a) \<in> ir \<longrightarrow> (e, b) \<in> ir) \<and> (\<forall> e . (e, b) \<in> ir \<longrightarrow> (e, a) \<in> ir)"
by (metis ir_push_and_pop4 lem_pop_ir_then_w1 not_ir_pop_push_ir pop_irI)

lemma lem_w1_then_ir : "(a, b) \<in> w1 \<Longrightarrow> is_push a \<Longrightarrow> is_pop b \<Longrightarrow> (a, b) \<in> ir"
by (smt Un_upper2 inf_sup_aci(5) ir_push_and_pop4 lem_push_pr_pop_then_ir lem_trancl_w1UnirD lem_w1_push_then_pr push_pop_ordered r_into_trancl' trancl_mono)

definition w1_pop :: "'a rel"
where
  "w1_pop = {(a, b) . is_pop a \<and> is_pop b \<and> (a, b) \<in> w1}"

lemma w1_popD : "(a, b) \<in> w1_pop \<Longrightarrow> is_pop a \<and> is_pop b \<and> (a, b) \<in> w1"
apply (unfold w1_pop_def)
by (simp)

lemma w1_popI : "is_pop a \<Longrightarrow> is_pop b \<Longrightarrow> (a, b) \<in> w1 \<Longrightarrow> (a, b) \<in> w1_pop"
apply (unfold w1_pop_def)
by (simp)

lemma w1_pop_transitive : "trans w1_pop"
by (metis lem_w1_transitive transE transI w1_popD w1_popI)

lemma w1_pop_irreflexive : "irrefl w1_pop"
by (metis acyclic_def irrefl_def lem_pr_ir_lin_acyclic w1_def w1_popD)

lemma w1_pop_antisymmetric : "antisym w1_pop"
by (metis antisymI irrefl_def transD w1_pop_irreflexive w1_pop_transitive)

lemma w1_pop_acyclic : "acyclic w1_pop"
by (metis lem_transitive_irreflexive_then_acyclic w1_pop_irreflexive w1_pop_transitive)

lemma w1_pop_then_w1 : "(a, b) \<in> w1_pop \<Longrightarrow> (a, b) \<in> w1"
by (metis w1_popD)

lemma trancl_w1_pop_then_trancl_w1 : "(a, b) \<in> trancl (w1_pop Un ir) \<Longrightarrow> (a, b) \<in> trancl (w1 Un ir)"
apply (erule trancl.induct)
apply (metis Un_iff r_into_trancl' w1_pop_then_w1)
by (metis Un_iff trancl.trancl_into_trancl w1_pop_then_w1)

lemma w1_pop_ir_acyclic : "acyclic (w1_pop Un ir)"
by (metis acyclic_def lem_w1_ir_acyclic trancl_w1_pop_then_trancl_w1)

definition pop_ops :: "'a set"
where
  "pop_ops = {a . is_pop a}"

lemma pop_ops_finite : "finite pop_ops"
by (metis pop_ops_def pops_finite)

lemma only_pops_in_pop_ops : "a \<in> pop_ops \<Longrightarrow> is_pop a"
by (metis mem_Collect_eq pop_ops_def)

inductive finite_pop_set :: "'a set \<Rightarrow> bool"
  where
    emptyI [simp, intro!]: "finite_pop_set {}"
  | insertI [simp, intro!]: "finite_pop_set A \<Longrightarrow> is_pop a \<Longrightarrow> finite_pop_set (insert a A)"

lemma only_pops_in_finite_pop_set_help : "finite_pop_set r \<Longrightarrow> \<forall> a . a \<notin> r \<or> (is_pop a)"
apply (erule finite_pop_set.induct)
apply (metis empty_iff)
by (metis insertE)

lemma only_pops_in_finite_pop_set : "finite_pop_set r \<Longrightarrow> a \<in> r \<Longrightarrow> is_pop a"
by (metis only_pops_in_finite_pop_set_help)

lemma pops_are_finite_pop_set_help : "finite r \<Longrightarrow> (\<exists> a . a \<in> r \<and> \<not>is_pop a) \<or> finite_pop_set r"
apply (erule finite.induct)
apply (metis emptyI)
by (metis insertCI insertI)

lemma pops_are_finite_pop_set : "finite_pop_set pop_ops"
apply (insert pop_ops_finite)
apply (drule pops_are_finite_pop_set_help)
apply (erule disjE)
apply (erule exE)
apply (erule conjE)
apply (drule only_pops_in_pop_ops)
apply metis
by assumption

inductive finite_pop_rel :: "'a rel \<Rightarrow> bool"
  where
    emptyI [simp, intro!]: "finite_pop_rel {}"
  | insertI [simp, intro!]: "finite_pop_rel A \<Longrightarrow> is_pop a \<Longrightarrow> is_pop b \<Longrightarrow> finite_pop_rel (insert (a, b) A)"

lemma only_pops_in_finite_pop_rel_help : "finite_pop_rel r \<Longrightarrow> \<forall> a b. (a, b) \<notin> r \<or> (is_pop a \<and> is_pop b)"
apply (erule finite_pop_rel.induct)
apply (metis empty_iff)
by (metis Pair_inject insertE)

lemma only_pops_in_finite_pop_rel : "finite_pop_rel r \<Longrightarrow> (a, b) \<in> r \<Longrightarrow> is_pop a \<and> is_pop b"
by (metis only_pops_in_finite_pop_rel_help)

lemma finite_pop_rel_union : "finite_pop_rel A \<Longrightarrow> finite_pop_rel B \<Longrightarrow> finite_pop_rel (A Un B)"
apply (induct rule: finite_pop_rel.induct) 
by simp_all

lemma pair_is_finite_pop_rel : "is_pop a \<Longrightarrow> is_pop b \<Longrightarrow> finite_pop_rel {(a, b)}"
by (metis finite_pop_rel.simps)

lemma finite_pop_relI_help3 : "{a} \<times> (insert aa A) = {a} \<times> A Un {(a, aa)} "
by (metis Sigma_empty1 Un_insert_right insert_times_insert sup_bot.left_neutral sup_bot.right_neutral)

lemma finite__pop_relI_help2 : "finite_pop_set A \<Longrightarrow> \<not>is_pop a \<or> finite_pop_rel ({a} \<times> A)"
apply (erule finite_pop_set.induct)
apply (metis Sigma_empty2 finite_pop_rel.emptyI)
apply (erule disjE)
apply (rule disjI1)
apply (assumption)
apply (rule_tac t="{a} \<times> insert aa A" and s="{a} \<times> A Un {(a, aa)}" in subst)
apply (metis finite_pop_relI_help3)
by (metis finite_pop_rel_union pair_is_finite_pop_rel)

lemma finite_relI_help1 : "insert a A \<times> B = A \<times> B Un {a} \<times> B"
by (metis Sigma_Un_distrib1 Un_commute insert_is_Un)

lemma finite_relI : "finite_pop_set A \<Longrightarrow> finite_pop_set B \<Longrightarrow> finite_pop_rel (A \<times> B)"
apply (erule finite_pop_set.induct)
apply (metis Sigma_empty1 finite_pop_rel.emptyI)
apply (rule_tac t="insert a A \<times> B" and s="A \<times> B Un {a} \<times> B" in subst)
apply (metis finite_relI_help1)
apply (rule finite_pop_rel_union)
apply assumption
by (metis finite__pop_relI_help2)


lemma pop_ops_rel_finite : "finite_pop_rel (pop_ops \<times> pop_ops)"
by (metis finite_relI pops_are_finite_pop_set)

lemma all_in_pop_ops_rel : "is_pop a \<Longrightarrow> is_pop b \<Longrightarrow> (a, b) \<in> (pop_ops \<times> pop_ops)"
by (metis SigmaI mem_Collect_eq pop_ops_def)

lemma w1_pop_in_pop_ops_rel : "w1_pop \<subseteq> (pop_ops \<times> pop_ops)"
apply (rule subrelI)
by (metis all_in_pop_ops_rel w1_popD)

lemma help_irreflexive : "trans r \<Longrightarrow> irrefl r \<Longrightarrow> antisym r \<Longrightarrow> (a, b) \<notin> r \<Longrightarrow> (b, a) \<notin> r \<Longrightarrow> a \<noteq> b \<Longrightarrow> irrefl (trancl (insert (a, b) r))"
by (metis acyclic_insert acyclic_irrefl rtranclD trancl_id)

lemma help_antisymmetric : "trans r \<Longrightarrow> irrefl r \<Longrightarrow> antisym r \<Longrightarrow> (a, b) \<notin> r \<Longrightarrow> (b, a) \<notin> r \<Longrightarrow> a \<noteq> b \<Longrightarrow> antisym (trancl (insert (a, b) r))"
by (metis acyclic_def acyclic_insert antisym_def lem_transitive_irreflexive_then_acyclic rtrancl_eq_or_trancl trancl_id trancl_trans)

lemma is_pop_preserved : "is_pop a \<Longrightarrow> is_pop b \<Longrightarrow> \<forall> c d . (c, d) \<in> r \<longrightarrow> is_pop c \<and> is_pop d \<Longrightarrow> (aa, ba) \<in> (insert (a, b) r) \<Longrightarrow> is_pop aa \<and> is_pop ba"
by (metis insert_iff prod.inject)

lemma r_is_pop_then_trancl_is_pop : "\<forall> a b . (a, b) \<in> r \<longrightarrow> is_pop a \<and> is_pop b \<Longrightarrow> (c, d) \<in> trancl r \<Longrightarrow> is_pop c \<and> is_pop d"
by (metis converse_tranclE trancl.cases)

definition w2 :: "'a rel \<Rightarrow> bool"
where
  "w2 r \<longleftrightarrow> w1_pop \<subseteq> r \<and> (ALL a b . (a, b) \<in> pop_ops \<times> pop_ops \<longrightarrow> a=b \<or> (a, b) \<in> r \<or> (b, a) \<in> r) \<and> trans r \<and> irrefl r \<and> antisym r \<and> (\<forall> a b . (a, b) \<in> r \<longrightarrow> is_pop a \<and> is_pop b)"

lemma lem_exists_total_closure : "(\<exists> r . w2 r)"
apply (unfold w2_def)
apply (insert pop_ops_rel_finite)
apply (erule finite_pop_rel.induct)
apply (metis empty_iff equalityE w1_popD w1_pop_antisymmetric w1_pop_irreflexive w1_pop_transitive)
apply (erule exE)
apply (case_tac "a=b")
apply (rule_tac x="r" in exI)
apply (erule conjE)+
apply (rule conjI)
apply (assumption)
apply (rule conjI)
apply (rule allI)+
apply (rule impI)
apply (unfold insert_def)
apply (erule UnE)
apply (metis (mono_tags) mem_Collect_eq prod.inject)
apply metis
apply metis
apply (case_tac "(a, b) \<in> r")
apply (rule_tac x="r" in exI)
apply (rule conjI)
apply metis
apply (rule conjI)
apply (rule allI)+
apply (rule impI)
apply (erule UnE)
apply (metis (full_types) mem_Collect_eq)
apply metis
apply metis
apply (case_tac "(b, a) \<in> r")
apply (rule_tac x="r" in exI)
apply (rule conjI)
apply metis
apply (rule conjI)
apply (rule allI)+
apply (rule impI)
apply (erule UnE)

apply (metis (mono_tags) mem_Collect_eq prod.inject)
apply metis
apply metis
apply (rule_tac x="trancl (insert (a, b) r)" in exI)
apply (rule conjI)
apply (metis r_into_trancl' subsetI subset_insertI2 subset_trans)
apply (erule conjE)+
apply (rule conjI)
apply (rule allI)+
apply (rule impI)
apply (erule UnE)
apply (metis (lifting) insert_compr mem_Collect_eq r_into_trancl')
apply (metis insert_iff r_into_trancl')
apply (rule conjI)
apply (metis trans_trancl)
apply (rule conjI)
apply (rule help_irreflexive)
apply (assumption)+
apply (rule conjI)
apply (rule help_antisymmetric)
apply (assumption)+
apply (rule allI)+
apply (rule impI)
apply (rule_tac r="insert (a, b) r" and c="aa" and d="ba" in r_is_pop_then_trancl_is_pop)
apply (metis is_pop_preserved)
by assumption

lemma lem_w2_then_pop : "w2 r \<Longrightarrow> (a, b) \<in> r \<Longrightarrow> is_pop a \<and> is_pop b"
by (metis w2_def)

lemma lem_w2_pop_total : "w2 r \<Longrightarrow> is_pop a \<Longrightarrow> is_pop b \<Longrightarrow> a \<noteq> b \<Longrightarrow> (a, b) \<in> r \<or> (b, a) \<in> r"
by (metis all_in_pop_ops_rel w2_def)

lemma lem_w2_antisymmetric : "w2 r \<Longrightarrow> antisym r"
by (metis w2_def)

lemma lem_w2_acyclic : "w2 r \<Longrightarrow> acyclic r"
by (metis lem_transitive_irreflexive_then_acyclic w2_def)

lemma lem_w2_transitive : "w2 r \<Longrightarrow> trans r"
by (metis w2_def)

lemma lem_preUw2_then_push_or_pop1 : "w2 r \<Longrightarrow> (a, b) \<in> pre Un r \<Longrightarrow> is_push a \<or> is_pop a"
by (metis Un_iff lem_push_or_pop1 lem_w2_then_pop)

lemma lem_preUw2_then_push_or_pop2 : "w2 r \<Longrightarrow> (a, b) \<in> pre Un r \<Longrightarrow> is_push b \<or> is_pop b"
by (metis Un_iff lem_push_or_pop2 lem_w2_then_pop)

lemma lem_pre_w2D_help : "w2 r \<Longrightarrow> (a, b) \<in> trancl (pre Un r) \<Longrightarrow> 
    is_push a \<or> (is_pop b \<and> (a, b) \<in> r) \<or> (a, b) \<in> pre \<or> (\<exists> c. is_pop c \<and> (a, c) \<in> r \<and> (c, b) \<in> pre)"
apply (erule trancl.induct)
apply (metis Un_iff lem_w2_then_pop)
apply (erule disjE)
apply metis
apply (frule_tac a="b" and b="c" in lem_preUw2_then_push_or_pop2)
apply (assumption)
apply (erule disjE)
apply (erule conjE)
apply (erule disjE)
apply (erule UnE)
apply metis
apply (metis ir_push_and_pop3 ir_push_and_pop4 lem_w2_then_pop push_pop_ordered)
apply (metis Un_iff lem_w2_transitive trans_def)
apply (erule disjE)
apply (metis pre_irreflexive UnE abcd_def def_value lem_irreflexive_then_not_equal lem_pop_then_push_exists lem_push_then_pop_exists lem_w2_then_pop pr_abcd val_order_def)
apply (erule disjE)
apply (frule lem_push_or_pop1)
apply (erule disjE)
apply metis
apply (frule lem_push_or_pop2)
apply (erule disjE)
apply (metis pre_irreflexive UnE abcdD ir_push_and_pop4 lem_irreflexive_then_not_equal lem_pop_pr_push_then_ir lem_w2_then_pop pr_abcd)
apply (smt UnE lem_pr_then_w1 lem_w2_transitive subsetD transD w1_popI w2_def)
by (smt pre_transitive UnE lem_pr_then_w1 lem_w2_transitive subsetD transD w1_popI w2_def)


lemma lem_pre_w2D : "w2 r \<Longrightarrow> (a, b) \<in> trancl (pre Un r) \<Longrightarrow> is_pop a \<Longrightarrow> is_push b \<Longrightarrow> (a, b) \<in> pre \<or> (\<exists> c. is_pop c \<and> (a, c) \<in> r \<and> (c, b) \<in> pre)"
by (metis lem_irreflexive_then_not_equal lem_pop_ir_irreflexive lem_pre_w2D_help not_ir_pop_push_ir pop_irI)

lemma lem_pre_w2D2_help : "w2 r \<Longrightarrow> (a, b) \<in> trancl (pre Un r) \<Longrightarrow> 
  is_pop a  \<or> (a, b) \<in> pre \<or> (is_push a \<and> (\<exists> c . is_pop c  \<and> (a, c) \<in> pre \<and> (c, b) \<in> trancl (pre Un r)))"
apply (erule trancl.induct)
apply (metis Un_iff lem_w2_then_pop)
by (metis Un_iff pre_transitive lem_push_or_pop1 lem_w2_then_pop trancl.r_into_trancl trancl.trancl_into_trancl trans_def)

lemma lem_pre_w2D2 : "w2 r \<Longrightarrow> (a, b) \<in> trancl (pre Un r) \<Longrightarrow> is_push a \<Longrightarrow> (a, b) \<in> pre \<or> (\<exists> c. is_pop c \<and> (a, c) \<in> pre \<and> (c, b) \<in> trancl (pre Un r))"
by (metis (hide_lams, no_types) def_value lem_pop_then_push_exists lem_pre_w2D2_help lem_push_then_pop_exists val_order_def)


lemma lem_tranclpreUw2_then_push_or_pop1 : "w2 r \<Longrightarrow> (a, b) \<in> trancl (pre Un r) \<Longrightarrow> is_push a \<or> is_pop a"
by (metis lem_pre_w2D2_help lem_push_or_pop1)

lemma lem_tranclpreUw2_then_push_or_pop2 : "w2 r \<Longrightarrow> (a, b) \<in> trancl (pre Un r) \<Longrightarrow> is_push b \<or> is_pop b"
by (metis (hide_lams, no_types) lem_preUw2_then_push_or_pop2 tranclE)


lemma lem_trancl_pre_w2D : "w2 r \<Longrightarrow> (a, b) \<in> trancl (pre Un r) \<Longrightarrow> is_push a \<or> is_push b \<or> (a, b) \<in> r"
apply (erule trancl.induct)
apply (erule UnE)
apply (frule lem_push_or_pop1)
apply (frule lem_push_or_pop2)
apply (erule disjE)+
apply metis
apply metis
apply (erule disjE)
apply metis
apply (metis lem_pr_then_w1 set_rev_mp w1_popI w2_def)
apply metis
apply (erule disjE)
apply metis
apply (erule disjE)
apply (frule_tac a="a" and b="b" in lem_tranclpreUw2_then_push_or_pop1)
apply (assumption)+
apply (erule disjE)
apply metis
apply (frule_tac a="a" and b="b" in lem_pre_w2D)
apply (assumption)+
apply (erule disjE)
apply (erule UnE)
apply (frule_tac a="b" and b="c" in lem_push_or_pop2)
apply (erule disjE)
apply metis
apply (metis (hide_lams, no_types) pre_irreflexive abcd_def irrefl_def lem_pr_then_w1 pr_abcd subsetD w1_popI w2_def)
apply (frule_tac a="b" and b="c" in lem_w2_then_pop)
apply (assumption)
apply (metis ir_push_and_pop4 lem_pop_pr_push_then_ir)
apply (frule_tac a="b" and b="c" in lem_preUw2_then_push_or_pop2)
apply (assumption)
apply (erule disjE)
apply metis
apply (smt pre_transitive UnE lem_pr_then_w1 lem_w2_transitive r_r_into_trancl subsetD trancl_id w1_popI w2_def)
apply (frule_tac a="b" and b="c" in lem_preUw2_then_push_or_pop2)
apply (assumption)
apply (erule disjE)
apply metis
by (smt UnE lem_pr_in_w1 lem_w2_transitive r_r_into_trancl subsetD trancl_id w1_popI w2_def)

lemma lem_w1_in_w2 : "w2 r \<Longrightarrow> (a, b) \<in> w1 \<Longrightarrow> is_pop a \<Longrightarrow> is_pop b \<Longrightarrow> (a, b) \<in> r"
by (metis set_rev_mp w1_popI w2_def)

lemma lem_not_w1_then_same_ir : "w2 r \<Longrightarrow> is_pop a \<Longrightarrow> is_pop b \<Longrightarrow> (a, b) \<in> r \<Longrightarrow> (a, b) \<notin> w1 \<Longrightarrow> (e, a) \<in> ir \<Longrightarrow> (e, b) \<in> ir"
apply (rotate_tac -2)
apply (erule contrapos_np)
apply (frule ir_push_and_pop4)
apply (assumption)
apply (drule not_ir_push_pop_ir)
apply (assumption)+
apply (drule_tac a="b" and b="a" and c="e" in pop_irI)
apply (assumption)+
apply (drule lem_pop_ir_then_w1)
by (metis acyclic_def ir_push_and_pop2 lem_w1_in_w2 lem_w2_acyclic r_r_into_trancl)

lemma lem_not_w1_then_same_ir2 : "w2 r \<Longrightarrow> is_pop a \<Longrightarrow> is_pop b \<Longrightarrow> (a, b) \<in> r \<Longrightarrow> (a, b) \<notin> w1 \<Longrightarrow> (a, e) \<in> ir \<Longrightarrow> (b, e) \<in> ir"
by (metis ir_push_and_pop3 lem_pop_ir_then_w1 not_ir_pop_push_ir pop_irI)

lemma lem_not_w1_then_same_ir3 : "w2 r \<Longrightarrow> is_pop a \<Longrightarrow> is_pop b \<Longrightarrow> (a, b) \<in> r \<Longrightarrow> (a, b) \<notin> w1 \<Longrightarrow> (b, e) \<in> ir \<Longrightarrow> (a, e) \<in> ir"
by (metis ir_push_and_pop3 lem_irreflexive_then_not_equal lem_not_w1_then_same_ir lem_pop_ir_irreflexive pop_irI push_pop_ordered)

lemma lem_pr_in_w2 : "w2 r \<Longrightarrow> is_pop a \<Longrightarrow> is_pop b \<Longrightarrow> (a, b) \<in> pre \<Longrightarrow> (a, b) \<in> r"
by (metis lem_w1_in_w2 lem_pr_then_w1)

lemma help_me : "w2 r \<Longrightarrow> (a, b) \<in> r \<Longrightarrow> (a, b) \<in> w1 \<or> ((c, a) \<in> ir \<longrightarrow> (c, b) \<in> ir)"
by (metis lem_not_w1_then_same_ir lem_w2_then_pop)

lemma lem_prUw2_then_w1Uir : "w2 r \<Longrightarrow> (a, b) \<in> trancl (pre Un r) \<Longrightarrow> (is_pop a \<and> is_pop b \<and> (a, b) \<in> r) \<or> (a, b) \<in> trancl (w1 Un ir)"
apply (erule trancl.induct)
apply (frule_tac a="a" and b="b" in lem_preUw2_then_push_or_pop1)
apply (assumption)
apply (frule_tac a="a" and b="b" in lem_preUw2_then_push_or_pop2)
apply (assumption)
apply (erule disjE)+
apply (metis UnE inf_sup_ord(3) lem_pr_then_w1 r_into_trancl' trancl_mono w2_def)
apply (metis UnE Un_upper2 lem_push_pr_pop_then_ir r_into_trancl' trancl_mono w2_def)
apply (erule disjE)
apply (metis Un_iff lem_pop_pr_push_then_ir r_into_trancl' w2_def)
apply (metis UnE lem_pr_in_w2)
apply (erule disjE)+
apply (erule conjE)
apply (frule_tac a="b" and b="c" in lem_preUw2_then_push_or_pop2)
apply (assumption)
apply (erule disjE)
apply (erule UnE)
apply (frule_tac a="c" and b="a" in push_pop_ordered)
apply (assumption)+
apply (erule disjE)
apply (erule conjE)
apply (frule_tac a="b" and b="c" in lem_pop_pr_push_then_ir)
apply (assumption)+
apply (case_tac "(a, b) \<in> w1")
apply (metis Un_iff r_r_into_trancl)
apply (metis (hide_lams, no_types) ins_def insI ipr_ooo_ir is_pop_def is_push_def lem_not_w1_then_same_ir lem_val_then_ir val_then_pr)
apply (metis Un_iff r_into_trancl')
apply (erule conjE)
apply (metis lem_pop_ir_then_w1 lem_pre_then_not_pop_ir lem_w1_push_then_pr lem_w2_then_pop pop_irI push_pop_ordered)
apply (metis (lifting) def_value lem_pop_then_push_exists lem_push_then_pop_exists lem_trancl_pre_w2D lem_w2_transitive r_r_into_trancl trancl.r_into_trancl trancl_id val_order_def)
apply (erule UnE)
apply (metis (hide_lams, no_types) UnCI lem_pr_in_w1 set_rev_mp trancl.trancl_into_trancl)
apply (frule_tac a="a" and b="b" in lem_tranclpreUw2_then_push_or_pop1)
apply (assumption)
apply (erule disjE)
apply (frule_tac a="b" and b="c" in lem_w2_then_pop)
apply (assumption)+
apply (erule conjE)
apply (frule_tac a="b" and b="c" and c="a" in help_me)
apply (assumption)
apply (erule disjE)
apply (metis (hide_lams, no_types) Un_iff trancl.simps)
apply (smt UnI1 Un_commute def_value lem_pop_then_push_exists lem_push_then_pop_exists lem_trancl_w1UnirD trancl.r_into_trancl val_order_def)
by (metis Un_iff def_value lem_pop_then_push_exists lem_push_then_pop_exists lem_trancl_pre_w2D trancl.trancl_into_trancl val_order_def w2_def)

(*w3 is trancl (w2 Un pre) *)

lemma lem_w3_irreflexive : "w2 r \<Longrightarrow> irrefl (trancl (pre Un r))"
by (metis acyclic_def irrefl_def lem_pop_ir_irreflexive lem_prUw2_then_w1Uir lem_trancl_pre_w2D lem_w1_ir_acyclic lem_w2_acyclic lem_w2_transitive pop_irI push_pop_ordered trancl_id)

lemma lem_w3_antisymmetric : "w2 r \<Longrightarrow> antisym (trancl (pre Un r))"
by (metis antisymI irrefl_def lem_w3_irreflexive trancl_trans)

lemma val_then_not_w3 : "w2 r \<Longrightarrow> (ia, ra) \<in> val \<Longrightarrow> (ra, ia) \<notin> trancl (pre Un r)"
by (metis Un_iff lem_irreflexive_then_not_equal lem_w3_irreflexive trancl.simps val_then_pr)

lemma lem_witness_wellformed : "w2 r \<Longrightarrow> wellformed_history (trancl (pre Un r)) val f"
apply (rule wellformed_historyI)
apply (metis trans_trancl)
apply (metis lem_w3_antisymmetric)
apply (metis lem_w3_irreflexive)
apply (metis operations_countable)
apply (metis operations_finite)
apply (metis def_push_once)
apply (metis def_pop_once)
apply (metis def_value)
apply (metis is_pop_def is_push_def lem_tranclpreUw2_then_push_or_pop1 lem_tranclpreUw2_then_push_or_pop2)
by (metis val_then_not_prI val_then_not_w3)

lemma lem_help_push_or_pop: "w2 r \<Longrightarrow> (a, b) \<in> ((pre \<union> r)\<^sup>+ \<union> ir)\<^sup>+ \<Longrightarrow> is_push a \<or> is_pop a"
apply (erule trancl.induct)
apply (metis UnE ir_push_and_pop lem_witness_wellformed wellformed_history.lem_push_or_pop1)
by metis

lemma lem_w3_acyclic_help : "w2 r \<Longrightarrow> (a, b) \<in> trancl ( (trancl (pre Un r)) Un ir) \<Longrightarrow> (is_pop a \<and> is_pop b \<and> (a, b) \<in> r) \<or> (a, b) \<in> trancl (w1 Un ir)"
apply (erule trancl.induct)
apply (metis Un_iff lem_irreflexive_then_not_equal lem_pop_ir_irreflexive lem_prUw2_then_w1Uir lem_trancl_pre_w2D pop_irI push_pop_ordered trancl.r_into_trancl)
apply (erule disjE)
apply (erule conjE)+
apply (erule UnE)
apply (frule_tac c="(a, b)" and A="pre" and B="r" in UnI2)
apply (smt lem_prUw2_then_w1Uir lem_trancl_pre_w2D trancl_into_trancl2 w2_def)
apply (case_tac "(a, b) \<in> w1")
apply (metis Un_iff r_r_into_trancl)
apply (frule_tac r="r" and a="a" and b="b" and e="c" in lem_not_w1_then_same_ir3)
apply (assumption)+
apply (metis UnCI r_into_trancl')
apply (erule UnE)
apply (frule_tac a="b" and b="c" and r="r" in lem_prUw2_then_w1Uir)
apply (assumption)
apply (erule disjE)
apply (erule conjE)+
apply (frule_tac a="a" and b="b" in lem_help_push_or_pop)
apply (assumption)
apply (erule disjE)+
apply (frule_tac a="a" and b="b" in push_pop_ordered)
apply (assumption)
apply (erule disjE)
apply (case_tac "(b, c) \<in> w1")
apply (metis Un_iff trancl.trancl_into_trancl)
apply (frule_tac r="r" and a="b" and b="c" and e="a" in lem_not_w1_then_same_ir)
apply (assumption)+
apply (metis Un_iff trancl.simps)
apply (smt insI ins_def ipr_ooo_ir ir_transitive lem_pop_then_push_exists lem_push_pr_pop_then_ir lem_push_then_pop_exists lem_trancl_w1UnirD lem_w1_then_ir val_then_pr)
apply (smt UnCI help_me lem_prUw2_then_w1Uir lem_trancl_w1UnirD lem_w1_in_w2 not_ir_pop_push_ir trancl.r_into_trancl trancl_into_trancl2 trancl_trans)
apply (metis trancl_trans)
by (metis Un_iff trancl.trancl_into_trancl)

lemma lem_w3_acyclic : "w2 r \<Longrightarrow> acyclic ((trancl (pre Un r)) \<union> ir)"
apply (unfold acyclic_def)
apply (rule allI)
apply (rule notI)
by (metis acyclic_def irrefl_trancl_rD lem_w1_ir_acyclic lem_w2_acyclic lem_w3_acyclic_help)

lemma lem_w3_pop_ordered : "w2 r \<Longrightarrow> is_pop a \<Longrightarrow> is_pop b \<Longrightarrow> a \<noteq> b \<Longrightarrow> (a, b) \<in> trancl (pre Un r) \<or> (b, a) \<in> trancl (pre Un r)"
by (metis Un_iff lem_w2_pop_total trancl.simps)



lemma lem_w3_then_ins : "w2 r \<Longrightarrow> is_push a \<Longrightarrow> is_push b \<Longrightarrow> (a, b) \<in> trancl (pre Un r) \<Longrightarrow> (a, b) \<in> ins"
by (smt insI ins_def ipr_ooo ir_push_and_pop3 ir_push_and_pop4 lem_prUw2_then_w1Uir lem_pr_then_ins lem_pre_w2D2 lem_push_then_pop_exists lem_trancl_w1UnirD push_pop_ordered val_then_pr)

lemma lem_w3ins_then_ins : "w2 r \<Longrightarrow> is_push a \<Longrightarrow> is_push b \<Longrightarrow> is_pop c \<Longrightarrow> (a, c) \<in> trancl (pre Un r) \<Longrightarrow> (c, b) \<in> ir \<Longrightarrow> (a, b) \<in> ins"
apply (frule_tac a="a" and b="c" in lem_pre_w2D2)
apply (assumption)+
apply (erule disjE)
apply (metis insI)
apply (erule exE)
apply (erule conjE)+
apply (frule_tac a="ca" and b="c" in lem_trancl_pre_w2D)
apply (assumption)
apply (erule disjE)
apply (metis lem_irreflexive_then_not_equal lem_pop_ir_irreflexive not_ir_pop_push_ir pop_irI)
apply (erule disjE)
apply (metis def_value is_pop_def is_push_def val_order_def)
apply (case_tac "(ca, c) \<in> w1")
apply (frule_tac a="b" and b="ca" in push_pop_ordered)
apply (assumption)
apply (erule disjE)
apply (frule_tac a="c" and b="ca" and c="b" in pop_irI)
apply (assumption)+
apply (metis acyclic_def lem_pop_ir_then_w1 lem_w1_in_w2 lem_w2_acyclic r_r_into_trancl)
apply (metis insI)
by (metis insI lem_not_w1_then_same_ir3)

lemma lem_wins_then_ins : "w2 r \<Longrightarrow> (a, b) \<in> (ins_order (trancl (pre Un r)) val ir) \<Longrightarrow> (a, b) \<in> ins"
apply (unfold ins_order_def)
apply (simp add:set_eq_iff)
apply (erule conjE)+
apply (erule disjE)
apply (metis isPush_def is_pushI lem_w3_then_ins)
by (metis ir_push_and_pop2 isPush_def is_pushI lem_w3ins_then_ins)

lemma lem_w3_ooo : "w2 r \<Longrightarrow>
            (ia, ra) \<in> val \<Longrightarrow>
            (ib, rb) \<in> val \<Longrightarrow>
            (ia, ib) \<in> ins_order ((pre \<union> r)\<^sup>+) val ir \<Longrightarrow> (ib, ra) \<in> ir \<Longrightarrow> (rb, ra) \<in> (pre \<union> r)\<^sup>+"
apply (frule_tac a="ia" and b="ib" in lem_wins_then_ins)
apply (assumption)
apply (frule_tac ia="ib" and ib="ia" and ra="rb" and rb="ra" in linI)
apply (assumption)+
apply (frule lem_lin_then_w1)
apply (frule_tac a="rb" and b="ra" in lem_w1_in_w2)
apply (assumption)
apply (metis is_pop_def)
apply (metis is_pop_def)
by (metis Un_iff r_into_trancl')

lemma lem_pr_in_w3 : "w2 r \<Longrightarrow> (a, b) \<in> pre \<Longrightarrow> (a, b) \<in> trancl (pre Un r)"
by (metis Un_iff r_into_trancl')

theorem remove_relaxed_stack_linearizable : "\<exists> prt .( pre \<subseteq> prt \<and> insert_pr_relaxed_stack prt val f ir)"
apply (insert lem_exists_total_closure)
apply (erule exE)
apply (rule_tac x="trancl (pre Un r)" in exI)
apply (rule conjI)
apply (metis Un_iff r_into_trancl' subsetI)
apply (unfold insert_pr_relaxed_stack_def)
apply (rule conjI)
apply (metis lem_witness_wellformed)
apply (unfold insert_pr_relaxed_stack_axioms_def)
apply (rule conjI)+
apply (metis lem_pr_in_w3 val_then_pr)
apply (metis lem_w3_pop_ordered)
apply (rule conjI)
apply (rule ir_alternating)
apply (rule conjI)
apply (metis lem_w3_acyclic)
apply (rule allI)+
by (metis lem_w3_ooo)

end

theorem remove_relaxed_stack_linearizable : "remove_relaxed_stack pre val f ir \<Longrightarrow> linearizable_non_empty_stack pre val"
apply (frule remove_relaxed_stack.remove_relaxed_stack_linearizable)
apply (erule exE)
apply (erule conjE)
apply (drule insert_pr_relaxed_stack.insert_pr_relaxed_stack_linearizable)
apply (erule exE)
apply (erule conjE)
apply (drule insert_relaxed_stack.insert_relaxed_stack_linearizable)
apply (erule exE)
apply (erule conjE)
apply (rule_tac prt="prtb" and f="f" in linearizable_non_empty_stackI)
apply (drule remove_relaxed_stackD)
apply (erule conjE)+
apply (drule wellformed_historyD)
apply (metis conc_historyI)
apply (metis subset_trans)
by (assumption)

end
